summaryrefslogtreecommitdiff
path: root/libc
diff options
context:
space:
mode:
authormarcus <marcus>2005-01-27 16:06:22 +0000
committermarcus <marcus>2005-01-27 16:06:22 +0000
commit6fb9b2965fca265d2496ed336db3a795ba3e2cff (patch)
tree0350e06ad32c20615df883c86ab54c6dd7638b8b /libc
parent3dcc51b3f1ceafca415a0c5c65c23fe9469c58f0 (diff)
2005-01-27 Marcus Brinkmann <marcus@gnu.org>
* patches/51-nptl-hurd-l4-tls.patch: New file.
Diffstat (limited to 'libc')
-rw-r--r--libc/ChangeLog2
-rwxr-xr-xlibc/patches/51-nptl-hurd-l4-tls.patch1077
2 files changed, 1079 insertions, 0 deletions
diff --git a/libc/ChangeLog b/libc/ChangeLog
index fca1d5b..9e64478 100644
--- a/libc/ChangeLog
+++ b/libc/ChangeLog
@@ -1,5 +1,7 @@
2005-01-27 Marcus Brinkmann <marcus@gnu.org>
+ * patches/51-nptl-hurd-l4-tls.patch: New file.
+
* patches/08-sysdeps-generic-dl-sysdep.patch: New file.
* hurd-l4/sysdeps/l4/hurd/getpagesize.c: Removed.
diff --git a/libc/patches/51-nptl-hurd-l4-tls.patch b/libc/patches/51-nptl-hurd-l4-tls.patch
new file mode 100755
index 0000000..c101c3c
--- /dev/null
+++ b/libc/patches/51-nptl-hurd-l4-tls.patch
@@ -0,0 +1,1077 @@
+#! /bin/sh
+patch -p1 -f $* < $0
+exit $?
+
+This patch adds TLS support for the Hurd on L4 to nptl.
+
+A better approach would possibly to keep the common code in
+libc/nptl/sysdeps/i386/tls.h, and have only the arch dependent stuff
+in the arch dirs.
+
+nptl/
+2004-01-27 Marcus Brinkmann <marcus@gnu.org
+
+ * sysdeps/i386/tls.h: Move to ...
+ * sysdeps/unix/sysv/linux/i386/tls.h: ... here.
+ * sysdeps/l4/hurd/i386/tls.h: New file.
+
+diff -rupN libc-prev/nptl/sysdeps/i386/tls.h libc/nptl/sysdeps/i386/tls.h
+--- libc-prev/nptl/sysdeps/i386/tls.h 2005-01-23 18:39:29.000000000 +0100
++++ libc/nptl/sysdeps/i386/tls.h 1970-01-01 01:00:00.000000000 +0100
+@@ -1,419 +0,0 @@
+-/* Definition for thread-local data handling. nptl/i386 version.
+- Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.
+- This file is part of the GNU C Library.
+-
+- The GNU C Library is free software; you can redistribute it and/or
+- modify it under the terms of the GNU Lesser General Public
+- License as published by the Free Software Foundation; either
+- version 2.1 of the License, or (at your option) any later version.
+-
+- The GNU C Library is distributed in the hope that it will be useful,
+- but WITHOUT ANY WARRANTY; without even the implied warranty of
+- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+- Lesser General Public License for more details.
+-
+- You should have received a copy of the GNU Lesser General Public
+- License along with the GNU C Library; if not, write to the Free
+- Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+- 02111-1307 USA. */
+-
+-#ifndef _TLS_H
+-#define _TLS_H 1
+-
+-#include <dl-sysdep.h>
+-#ifndef __ASSEMBLER__
+-# include <stdbool.h>
+-# include <stddef.h>
+-# include <stdint.h>
+-# include <stdlib.h>
+-# include <list.h>
+-
+-
+-/* Type for the dtv. */
+-typedef union dtv
+-{
+- size_t counter;
+- struct
+- {
+- void *val;
+- bool is_static;
+- } pointer;
+-} dtv_t;
+-
+-
+-typedef struct
+-{
+- void *tcb; /* Pointer to the TCB. Not necessary the
+- thread descriptor used by libpthread. */
+- dtv_t *dtv;
+- void *self; /* Pointer to the thread descriptor. */
+- int multiple_threads;
+- uintptr_t sysinfo;
+-} tcbhead_t;
+-
+-# define TLS_MULTIPLE_THREADS_IN_TCB 1
+-
+-#else /* __ASSEMBLER__ */
+-# include <tcb-offsets.h>
+-#endif
+-
+-
+-/* We require TLS support in the tools. */
+-#ifndef HAVE_TLS_SUPPORT
+-# error "TLS support is required."
+-#endif
+-
+-/* Signal that TLS support is available. */
+-#define USE_TLS 1
+-
+-/* Alignment requirement for the stack. For IA-32 this is governed by
+- the SSE memory functions. */
+-#define STACK_ALIGN 16
+-
+-#ifndef __ASSEMBLER__
+-/* Get system call information. */
+-# include <sysdep.h>
+-
+-/* The old way: using LDT. */
+-
+-/* Structure passed to `modify_ldt', 'set_thread_area', and 'clone' calls. */
+-struct user_desc
+-{
+- unsigned int entry_number;
+- unsigned long int base_addr;
+- unsigned int limit;
+- unsigned int seg_32bit:1;
+- unsigned int contents:2;
+- unsigned int read_exec_only:1;
+- unsigned int limit_in_pages:1;
+- unsigned int seg_not_present:1;
+- unsigned int useable:1;
+- unsigned int empty:25;
+-};
+-
+-/* Initializing bit fields is slow. We speed it up by using a union. */
+-union user_desc_init
+-{
+- struct user_desc desc;
+- unsigned int vals[4];
+-};
+-
+-
+-/* Get the thread descriptor definition. */
+-# include <nptl/descr.h>
+-
+-/* This is the size of the initial TCB. */
+-# define TLS_INIT_TCB_SIZE sizeof (tcbhead_t)
+-
+-/* Alignment requirements for the initial TCB. */
+-# define TLS_INIT_TCB_ALIGN __alignof__ (tcbhead_t)
+-
+-/* This is the size of the TCB. */
+-# define TLS_TCB_SIZE sizeof (struct pthread)
+-
+-/* Alignment requirements for the TCB. */
+-# define TLS_TCB_ALIGN __alignof__ (struct pthread)
+-
+-/* The TCB can have any size and the memory following the address the
+- thread pointer points to is unspecified. Allocate the TCB there. */
+-# define TLS_TCB_AT_TP 1
+-
+-
+-/* Install the dtv pointer. The pointer passed is to the element with
+- index -1 which contain the length. */
+-# define INSTALL_DTV(descr, dtvp) \
+- ((tcbhead_t *) (descr))->dtv = (dtvp) + 1
+-
+-/* Install new dtv for current thread. */
+-# define INSTALL_NEW_DTV(dtvp) \
+- ({ struct pthread *__pd; \
+- THREAD_SETMEM (__pd, header.dtv, (dtvp)); })
+-
+-/* Return dtv of given thread descriptor. */
+-# define GET_DTV(descr) \
+- (((tcbhead_t *) (descr))->dtv)
+-
+-#define THREAD_SELF_SYSINFO THREAD_GETMEM (THREAD_SELF, header.sysinfo)
+-#define THREAD_SYSINFO(pd) ((pd)->header.sysinfo)
+-
+-/* Macros to load from and store into segment registers. */
+-# ifndef TLS_GET_GS
+-# define TLS_GET_GS() \
+- ({ int __seg; __asm ("movw %%gs, %w0" : "=q" (__seg)); __seg & 0xffff; })
+-# endif
+-# ifndef TLS_SET_GS
+-# define TLS_SET_GS(val) \
+- __asm ("movw %w0, %%gs" :: "q" (val))
+-# endif
+-
+-
+-# ifndef __NR_set_thread_area
+-# define __NR_set_thread_area 243
+-# endif
+-# ifndef TLS_FLAG_WRITABLE
+-# define TLS_FLAG_WRITABLE 0x00000001
+-# endif
+-
+-// XXX Enable for the real world.
+-#if 0
+-# ifndef __ASSUME_SET_THREAD_AREA
+-# error "we need set_thread_area"
+-# endif
+-#endif
+-
+-# ifdef __PIC__
+-# define TLS_EBX_ARG "r"
+-# define TLS_LOAD_EBX "xchgl %3, %%ebx\n\t"
+-# else
+-# define TLS_EBX_ARG "b"
+-# define TLS_LOAD_EBX
+-# endif
+-
+-#if defined NEED_DL_SYSINFO
+-# define INIT_SYSINFO \
+- _head->sysinfo = GLRO(dl_sysinfo)
+-#else
+-# define INIT_SYSINFO
+-#endif
+-
+-#ifndef LOCK_PREFIX
+-# ifdef UP
+-# define LOCK_PREFIX /* nothing */
+-# else
+-# define LOCK_PREFIX "lock;"
+-# endif
+-#endif
+-
+-/* Code to initially initialize the thread pointer. This might need
+- special attention since 'errno' is not yet available and if the
+- operation can cause a failure 'errno' must not be touched. */
+-# define TLS_INIT_TP(thrdescr, secondcall) \
+- ({ void *_thrdescr = (thrdescr); \
+- tcbhead_t *_head = _thrdescr; \
+- union user_desc_init _segdescr; \
+- int _result; \
+- \
+- _head->tcb = _thrdescr; \
+- /* For now the thread descriptor is at the same address. */ \
+- _head->self = _thrdescr; \
+- /* New syscall handling support. */ \
+- INIT_SYSINFO; \
+- \
+- /* The 'entry_number' field. Let the kernel pick a value. */ \
+- if (secondcall) \
+- _segdescr.vals[0] = TLS_GET_GS () >> 3; \
+- else \
+- _segdescr.vals[0] = -1; \
+- /* The 'base_addr' field. Pointer to the TCB. */ \
+- _segdescr.vals[1] = (unsigned long int) _thrdescr; \
+- /* The 'limit' field. We use 4GB which is 0xfffff pages. */ \
+- _segdescr.vals[2] = 0xfffff; \
+- /* Collapsed value of the bitfield: \
+- .seg_32bit = 1 \
+- .contents = 0 \
+- .read_exec_only = 0 \
+- .limit_in_pages = 1 \
+- .seg_not_present = 0 \
+- .useable = 1 */ \
+- _segdescr.vals[3] = 0x51; \
+- \
+- /* Install the TLS. */ \
+- asm volatile (TLS_LOAD_EBX \
+- "int $0x80\n\t" \
+- TLS_LOAD_EBX \
+- : "=a" (_result), "=m" (_segdescr.desc.entry_number) \
+- : "0" (__NR_set_thread_area), \
+- TLS_EBX_ARG (&_segdescr.desc), "m" (_segdescr.desc)); \
+- \
+- if (_result == 0) \
+- /* We know the index in the GDT, now load the segment register. \
+- The use of the GDT is described by the value 3 in the lower \
+- three bits of the segment descriptor value. \
+- \
+- Note that we have to do this even if the numeric value of \
+- the descriptor does not change. Loading the segment register \
+- causes the segment information from the GDT to be loaded \
+- which is necessary since we have changed it. */ \
+- TLS_SET_GS (_segdescr.desc.entry_number * 8 + 3); \
+- \
+- _result == 0 ? NULL \
+- : "set_thread_area failed when setting up thread-local storage\n"; })
+-
+-
+-/* Return the address of the dtv for the current thread. */
+-# define THREAD_DTV() \
+- ({ struct pthread *__pd; \
+- THREAD_GETMEM (__pd, header.dtv); })
+-
+-
+-/* Return the thread descriptor for the current thread.
+-
+- The contained asm must *not* be marked volatile since otherwise
+- assignments like
+- pthread_descr self = thread_self();
+- do not get optimized away. */
+-# define THREAD_SELF \
+- ({ struct pthread *__self; \
+- asm ("movl %%gs:%c1,%0" : "=r" (__self) \
+- : "i" (offsetof (struct pthread, header.self))); \
+- __self;})
+-
+-/* Magic for libthread_db to know how to do THREAD_SELF. */
+-# define DB_THREAD_SELF \
+- REGISTER_THREAD_AREA (32, offsetof (struct user_regs_struct, xgs), 3) \
+- REGISTER_THREAD_AREA (64, 26 * 8, 3) /* x86-64's user_regs_struct->gs */
+-
+-
+-/* Read member of the thread descriptor directly. */
+-# define THREAD_GETMEM(descr, member) \
+- ({ __typeof (descr->member) __value; \
+- if (sizeof (__value) == 1) \
+- asm volatile ("movb %%gs:%P2,%b0" \
+- : "=q" (__value) \
+- : "0" (0), "i" (offsetof (struct pthread, member))); \
+- else if (sizeof (__value) == 4) \
+- asm volatile ("movl %%gs:%P1,%0" \
+- : "=r" (__value) \
+- : "i" (offsetof (struct pthread, member))); \
+- else \
+- { \
+- if (sizeof (__value) != 8) \
+- /* There should not be any value with a size other than 1, \
+- 4 or 8. */ \
+- abort (); \
+- \
+- asm volatile ("movl %%gs:%P1,%%eax\n\t" \
+- "movl %%gs:%P2,%%edx" \
+- : "=A" (__value) \
+- : "i" (offsetof (struct pthread, member)), \
+- "i" (offsetof (struct pthread, member) + 4)); \
+- } \
+- __value; })
+-
+-
+-/* Same as THREAD_GETMEM, but the member offset can be non-constant. */
+-# define THREAD_GETMEM_NC(descr, member, idx) \
+- ({ __typeof (descr->member[0]) __value; \
+- if (sizeof (__value) == 1) \
+- asm volatile ("movb %%gs:%P2(%3),%b0" \
+- : "=q" (__value) \
+- : "0" (0), "i" (offsetof (struct pthread, member[0])), \
+- "r" (idx)); \
+- else if (sizeof (__value) == 4) \
+- asm volatile ("movl %%gs:%P1(,%2,4),%0" \
+- : "=r" (__value) \
+- : "i" (offsetof (struct pthread, member[0])), \
+- "r" (idx)); \
+- else \
+- { \
+- if (sizeof (__value) != 8) \
+- /* There should not be any value with a size other than 1, \
+- 4 or 8. */ \
+- abort (); \
+- \
+- asm volatile ("movl %%gs:%P1(,%2,8),%%eax\n\t" \
+- "movl %%gs:4+%P1(,%2,8),%%edx" \
+- : "=&A" (__value) \
+- : "i" (offsetof (struct pthread, member[0])), \
+- "r" (idx)); \
+- } \
+- __value; })
+-
+-
+-/* Same as THREAD_SETMEM, but the member offset can be non-constant. */
+-# define THREAD_SETMEM(descr, member, value) \
+- ({ if (sizeof (descr->member) == 1) \
+- asm volatile ("movb %b0,%%gs:%P1" : \
+- : "iq" (value), \
+- "i" (offsetof (struct pthread, member))); \
+- else if (sizeof (descr->member) == 4) \
+- asm volatile ("movl %0,%%gs:%P1" : \
+- : "ir" (value), \
+- "i" (offsetof (struct pthread, member))); \
+- else \
+- { \
+- if (sizeof (descr->member) != 8) \
+- /* There should not be any value with a size other than 1, \
+- 4 or 8. */ \
+- abort (); \
+- \
+- asm volatile ("movl %%eax,%%gs:%P1\n\t" \
+- "movl %%edx,%%gs:%P2" : \
+- : "A" (value), \
+- "i" (offsetof (struct pthread, member)), \
+- "i" (offsetof (struct pthread, member) + 4)); \
+- }})
+-
+-
+-/* Set member of the thread descriptor directly. */
+-# define THREAD_SETMEM_NC(descr, member, idx, value) \
+- ({ if (sizeof (descr->member[0]) == 1) \
+- asm volatile ("movb %b0,%%gs:%P1(%2)" : \
+- : "iq" (value), \
+- "i" (offsetof (struct pthread, member)), \
+- "r" (idx)); \
+- else if (sizeof (descr->member[0]) == 4) \
+- asm volatile ("movl %0,%%gs:%P1(,%2,4)" : \
+- : "ir" (value), \
+- "i" (offsetof (struct pthread, member)), \
+- "r" (idx)); \
+- else \
+- { \
+- if (sizeof (descr->member[0]) != 8) \
+- /* There should not be any value with a size other than 1, \
+- 4 or 8. */ \
+- abort (); \
+- \
+- asm volatile ("movl %%eax,%%gs:%P1(,%2,8)\n\t" \
+- "movl %%edx,%%gs:4+%P1(,%2,8)" : \
+- : "A" (value), \
+- "i" (offsetof (struct pthread, member)), \
+- "r" (idx)); \
+- }})
+-
+-
+-/* Atomic compare and exchange on TLS, returning old value. */
+-#define THREAD_ATOMIC_CMPXCHG_VAL(descr, member, newval, oldval) \
+- ({ __typeof (descr->member) __ret; \
+- __typeof (oldval) __old = (oldval); \
+- if (sizeof (descr->member) == 4) \
+- asm volatile (LOCK_PREFIX "cmpxchgl %2, %%gs:%P3" \
+- : "=a" (__ret) \
+- : "0" (__old), "r" (newval), \
+- "i" (offsetof (struct pthread, member))); \
+- else \
+- /* Not necessary for other sizes in the moment. */ \
+- abort (); \
+- __ret; })
+-
+-
+-/* Atomic set bit. */
+-#define THREAD_ATOMIC_BIT_SET(descr, member, bit) \
+- (void) ({ if (sizeof ((descr)->member) == 4) \
+- asm volatile (LOCK_PREFIX "orl %1, %%gs:%P0" \
+- :: "i" (offsetof (struct pthread, member)), \
+- "ir" (1 << (bit))); \
+- else \
+- /* Not necessary for other sizes in the moment. */ \
+- abort (); })
+-
+-
+-/* Call the user-provided thread function. */
+-#define CALL_THREAD_FCT(descr) \
+- ({ void *__res; \
+- int __ignore1, __ignore2; \
+- asm volatile ("pushl %%eax\n\t" \
+- "pushl %%eax\n\t" \
+- "pushl %%eax\n\t" \
+- "pushl %%gs:%P4\n\t" \
+- "call *%%gs:%P3\n\t" \
+- "addl $16, %%esp" \
+- : "=a" (__res), "=c" (__ignore1), "=d" (__ignore2) \
+- : "i" (offsetof (struct pthread, start_routine)), \
+- "i" (offsetof (struct pthread, arg))); \
+- __res; })
+-
+-
+-#endif /* __ASSEMBLER__ */
+-
+-#endif /* tls.h */
+diff -rupN libc-prev/nptl/sysdeps/l4/hurd/i386/tls.h libc/nptl/sysdeps/l4/hurd/i386/tls.h
+--- libc-prev/nptl/sysdeps/l4/hurd/i386/tls.h 1970-01-01 01:00:00.000000000 +0100
++++ libc/nptl/sysdeps/l4/hurd/i386/tls.h 2005-01-26 16:58:30.000000000 +0100
+@@ -0,0 +1,210 @@
++/* Definition for thread-local data handling. nptl/i386 version.
++ Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.
++ This file is part of the GNU C Library.
++
++ The GNU C Library is free software; you can redistribute it and/or
++ modify it under the terms of the GNU Lesser General Public
++ License as published by the Free Software Foundation; either
++ version 2.1 of the License, or (at your option) any later version.
++
++ The GNU C Library is distributed in the hope that it will be useful,
++ but WITHOUT ANY WARRANTY; without even the implied warranty of
++ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
++ Lesser General Public License for more details.
++
++ You should have received a copy of the GNU Lesser General Public
++ License along with the GNU C Library; if not, write to the Free
++ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
++ 02111-1307 USA. */
++
++#ifndef _TLS_H
++#define _TLS_H 1
++
++#include <dl-sysdep.h>
++#ifndef __ASSEMBLER__
++# include <stdbool.h>
++# include <stddef.h>
++# include <stdint.h>
++# include <stdlib.h>
++# include <list.h>
++
++
++/* Type for the dtv. */
++typedef union dtv
++{
++ size_t counter;
++ struct
++ {
++ void *val;
++ bool is_static;
++ } pointer;
++} dtv_t;
++
++
++typedef struct
++{
++ void *tcb; /* Pointer to the TCB. Not necessary the
++ thread descriptor used by libpthread. */
++ dtv_t *dtv;
++ void *self; /* Pointer to the thread descriptor. */
++ int multiple_threads;
++ uintptr_t sysinfo;
++} tcbhead_t;
++
++# define TLS_MULTIPLE_THREADS_IN_TCB 1
++
++#else /* __ASSEMBLER__ */
++# include <tcb-offsets.h>
++#endif
++
++
++/* We require TLS support in the tools. */
++#ifndef HAVE_TLS_SUPPORT
++# error "TLS support is required."
++#endif
++
++/* Signal that TLS support is available. */
++#define USE_TLS 1
++
++/* Alignment requirement for the stack. For IA-32 this is governed by
++ the SSE memory functions. */
++#define STACK_ALIGN 16
++
++#ifndef __ASSEMBLER__
++/* Get system call information. */
++# include <sysdep.h>
++
++
++/* Get the thread descriptor definition. */
++# include <nptl/descr.h>
++
++/* This is the size of the initial TCB. */
++# define TLS_INIT_TCB_SIZE sizeof (tcbhead_t)
++
++/* Alignment requirements for the initial TCB. */
++# define TLS_INIT_TCB_ALIGN __alignof__ (tcbhead_t)
++
++/* This is the size of the TCB. */
++# define TLS_TCB_SIZE sizeof (struct pthread)
++
++/* Alignment requirements for the TCB. */
++# define TLS_TCB_ALIGN __alignof__ (struct pthread)
++
++/* The TCB can have any size and the memory following the address the
++ thread pointer points to is unspecified. Allocate the TCB there. */
++# define TLS_TCB_AT_TP 1
++
++
++/* Install the dtv pointer. The pointer passed is to the element with
++ index -1 which contain the length. */
++# define INSTALL_DTV(descr, dtvp) \
++ ((tcbhead_t *) (descr))->dtv = (dtvp) + 1
++
++/* Install new dtv for current thread. */
++# define INSTALL_NEW_DTV(dtvp) \
++ ({ struct pthread *__pd; \
++ THREAD_SETMEM (__pd, header.dtv, (dtvp)); })
++
++/* Return dtv of given thread descriptor. */
++# define GET_DTV(descr) \
++ (((tcbhead_t *) (descr))->dtv)
++
++#define THREAD_SELF_SYSINFO THREAD_GETMEM (THREAD_SELF, header.sysinfo)
++#define THREAD_SYSINFO(pd) ((pd)->header.sysinfo)
++
++
++# ifndef __NR_set_thread_area
++# define __NR_set_thread_area 243
++# endif
++# ifndef TLS_FLAG_WRITABLE
++# define TLS_FLAG_WRITABLE 0x00000001
++# endif
++
++// XXX Enable for the real world.
++#if 0
++# ifndef __ASSUME_SET_THREAD_AREA
++# error "we need set_thread_area"
++# endif
++#endif
++
++# ifdef __PIC__
++# define TLS_EBX_ARG "r"
++# define TLS_LOAD_EBX "xchgl %3, %%ebx\n\t"
++# else
++# define TLS_EBX_ARG "b"
++# define TLS_LOAD_EBX
++# endif
++
++#if defined NEED_DL_SYSINFO
++# define INIT_SYSINFO \
++ _head->sysinfo = GLRO(dl_sysinfo)
++#else
++# define INIT_SYSINFO
++#endif
++
++#ifndef LOCK_PREFIX
++# ifdef UP
++# define LOCK_PREFIX /* nothing */
++# else
++# define LOCK_PREFIX "lock;"
++# endif
++#endif
++
++#include <l4/arch.h>
++
++/* Code to initially initialize the thread pointer. This might need
++ special attention since 'errno' is not yet available and if the
++ operation can cause a failure 'errno' must not be touched. */
++# define TLS_INIT_TP(thrdescr, secondcall) \
++ ({ void *_thrdescr = (thrdescr); \
++ tcbhead_t *_head = _thrdescr; \
++ int _result; \
++ \
++ _head->tcb = _thrdescr; \
++ /* For now the thread descriptor is at the same address. */ \
++ _head->self = _thrdescr; \
++ /* New syscall handling support. */ \
++ INIT_SYSINFO; \
++ \
++ /* Install the pointer to the TCB. */ \
++ l4_set_gs0 ((l4_word_t) _thrdescr); \
++ \
++ NULL; })
++
++
++/* Return the address of the dtv for the current thread. */
++# define THREAD_DTV() \
++ ({ struct pthread *__pd; \
++ THREAD_GETMEM (__pd, header.dtv); })
++
++
++/* Return the thread descriptor for the current thread.
++
++ The contained asm must *not* be marked volatile since otherwise
++ assignments like
++ pthread_descr self = thread_self();
++ do not get optimized away. */
++# define THREAD_SELF \
++ ({ tcbhead_t *_head; \
++ asm ("movl %%gs:0,%0" : "=r" (_head)); \
++ (struct pthread *) _head->self;})
++
++/* Magic for libthread_db to know how to do THREAD_SELF. */
++# define DB_THREAD_SELF \
++ REGISTER_THREAD_AREA (32, offsetof (struct user_regs_struct, xgs), 3) \
++ REGISTER_THREAD_AREA (64, 26 * 8, 3) /* x86-64's user_regs_struct->gs */
++
++
++/* Access to data in the thread descriptor is easy. */
++#define THREAD_GETMEM(descr, member) \
++ descr->member
++#define THREAD_GETMEM_NC(descr, member, idx) \
++ descr->member[idx]
++#define THREAD_SETMEM(descr, member, value) \
++ descr->member = (value)
++#define THREAD_SETMEM_NC(descr, member, idx, value) \
++ descr->member[idx] = (value)
++
++#endif /* __ASSEMBLER__ */
++
++#endif /* tls.h */
+diff -rupN libc-prev/nptl/sysdeps/unix/sysv/linux/i386/tls.h libc/nptl/sysdeps/unix/sysv/linux/i386/tls.h
+--- libc-prev/nptl/sysdeps/unix/sysv/linux/i386/tls.h 1970-01-01 01:00:00.000000000 +0100
++++ libc/nptl/sysdeps/unix/sysv/linux/i386/tls.h 2005-01-23 18:39:29.000000000 +0100
+@@ -0,0 +1,419 @@
++/* Definition for thread-local data handling. nptl/i386 version.
++ Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.
++ This file is part of the GNU C Library.
++
++ The GNU C Library is free software; you can redistribute it and/or
++ modify it under the terms of the GNU Lesser General Public
++ License as published by the Free Software Foundation; either
++ version 2.1 of the License, or (at your option) any later version.
++
++ The GNU C Library is distributed in the hope that it will be useful,
++ but WITHOUT ANY WARRANTY; without even the implied warranty of
++ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
++ Lesser General Public License for more details.
++
++ You should have received a copy of the GNU Lesser General Public
++ License along with the GNU C Library; if not, write to the Free
++ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
++ 02111-1307 USA. */
++
++#ifndef _TLS_H
++#define _TLS_H 1
++
++#include <dl-sysdep.h>
++#ifndef __ASSEMBLER__
++# include <stdbool.h>
++# include <stddef.h>
++# include <stdint.h>
++# include <stdlib.h>
++# include <list.h>
++
++
++/* Type for the dtv. */
++typedef union dtv
++{
++ size_t counter;
++ struct
++ {
++ void *val;
++ bool is_static;
++ } pointer;
++} dtv_t;
++
++
++typedef struct
++{
++ void *tcb; /* Pointer to the TCB. Not necessary the
++ thread descriptor used by libpthread. */
++ dtv_t *dtv;
++ void *self; /* Pointer to the thread descriptor. */
++ int multiple_threads;
++ uintptr_t sysinfo;
++} tcbhead_t;
++
++# define TLS_MULTIPLE_THREADS_IN_TCB 1
++
++#else /* __ASSEMBLER__ */
++# include <tcb-offsets.h>
++#endif
++
++
++/* We require TLS support in the tools. */
++#ifndef HAVE_TLS_SUPPORT
++# error "TLS support is required."
++#endif
++
++/* Signal that TLS support is available. */
++#define USE_TLS 1
++
++/* Alignment requirement for the stack. For IA-32 this is governed by
++ the SSE memory functions. */
++#define STACK_ALIGN 16
++
++#ifndef __ASSEMBLER__
++/* Get system call information. */
++# include <sysdep.h>
++
++/* The old way: using LDT. */
++
++/* Structure passed to `modify_ldt', 'set_thread_area', and 'clone' calls. */
++struct user_desc
++{
++ unsigned int entry_number;
++ unsigned long int base_addr;
++ unsigned int limit;
++ unsigned int seg_32bit:1;
++ unsigned int contents:2;
++ unsigned int read_exec_only:1;
++ unsigned int limit_in_pages:1;
++ unsigned int seg_not_present:1;
++ unsigned int useable:1;
++ unsigned int empty:25;
++};
++
++/* Initializing bit fields is slow. We speed it up by using a union. */
++union user_desc_init
++{
++ struct user_desc desc;
++ unsigned int vals[4];
++};
++
++
++/* Get the thread descriptor definition. */
++# include <nptl/descr.h>
++
++/* This is the size of the initial TCB. */
++# define TLS_INIT_TCB_SIZE sizeof (tcbhead_t)
++
++/* Alignment requirements for the initial TCB. */
++# define TLS_INIT_TCB_ALIGN __alignof__ (tcbhead_t)
++
++/* This is the size of the TCB. */
++# define TLS_TCB_SIZE sizeof (struct pthread)
++
++/* Alignment requirements for the TCB. */
++# define TLS_TCB_ALIGN __alignof__ (struct pthread)
++
++/* The TCB can have any size and the memory following the address the
++ thread pointer points to is unspecified. Allocate the TCB there. */
++# define TLS_TCB_AT_TP 1
++
++
++/* Install the dtv pointer. The pointer passed is to the element with
++ index -1 which contain the length. */
++# define INSTALL_DTV(descr, dtvp) \
++ ((tcbhead_t *) (descr))->dtv = (dtvp) + 1
++
++/* Install new dtv for current thread. */
++# define INSTALL_NEW_DTV(dtvp) \
++ ({ struct pthread *__pd; \
++ THREAD_SETMEM (__pd, header.dtv, (dtvp)); })
++
++/* Return dtv of given thread descriptor. */
++# define GET_DTV(descr) \
++ (((tcbhead_t *) (descr))->dtv)
++
++#define THREAD_SELF_SYSINFO THREAD_GETMEM (THREAD_SELF, header.sysinfo)
++#define THREAD_SYSINFO(pd) ((pd)->header.sysinfo)
++
++/* Macros to load from and store into segment registers. */
++# ifndef TLS_GET_GS
++# define TLS_GET_GS() \
++ ({ int __seg; __asm ("movw %%gs, %w0" : "=q" (__seg)); __seg & 0xffff; })
++# endif
++# ifndef TLS_SET_GS
++# define TLS_SET_GS(val) \
++ __asm ("movw %w0, %%gs" :: "q" (val))
++# endif
++
++
++# ifndef __NR_set_thread_area
++# define __NR_set_thread_area 243
++# endif
++# ifndef TLS_FLAG_WRITABLE
++# define TLS_FLAG_WRITABLE 0x00000001
++# endif
++
++// XXX Enable for the real world.
++#if 0
++# ifndef __ASSUME_SET_THREAD_AREA
++# error "we need set_thread_area"
++# endif
++#endif
++
++# ifdef __PIC__
++# define TLS_EBX_ARG "r"
++# define TLS_LOAD_EBX "xchgl %3, %%ebx\n\t"
++# else
++# define TLS_EBX_ARG "b"
++# define TLS_LOAD_EBX
++# endif
++
++#if defined NEED_DL_SYSINFO
++# define INIT_SYSINFO \
++ _head->sysinfo = GLRO(dl_sysinfo)
++#else
++# define INIT_SYSINFO
++#endif
++
++#ifndef LOCK_PREFIX
++# ifdef UP
++# define LOCK_PREFIX /* nothing */
++# else
++# define LOCK_PREFIX "lock;"
++# endif
++#endif
++
++/* Code to initially initialize the thread pointer. This might need
++ special attention since 'errno' is not yet available and if the
++ operation can cause a failure 'errno' must not be touched. */
++# define TLS_INIT_TP(thrdescr, secondcall) \
++ ({ void *_thrdescr = (thrdescr); \
++ tcbhead_t *_head = _thrdescr; \
++ union user_desc_init _segdescr; \
++ int _result; \
++ \
++ _head->tcb = _thrdescr; \
++ /* For now the thread descriptor is at the same address. */ \
++ _head->self = _thrdescr; \
++ /* New syscall handling support. */ \
++ INIT_SYSINFO; \
++ \
++ /* The 'entry_number' field. Let the kernel pick a value. */ \
++ if (secondcall) \
++ _segdescr.vals[0] = TLS_GET_GS () >> 3; \
++ else \
++ _segdescr.vals[0] = -1; \
++ /* The 'base_addr' field. Pointer to the TCB. */ \
++ _segdescr.vals[1] = (unsigned long int) _thrdescr; \
++ /* The 'limit' field. We use 4GB which is 0xfffff pages. */ \
++ _segdescr.vals[2] = 0xfffff; \
++ /* Collapsed value of the bitfield: \
++ .seg_32bit = 1 \
++ .contents = 0 \
++ .read_exec_only = 0 \
++ .limit_in_pages = 1 \
++ .seg_not_present = 0 \
++ .useable = 1 */ \
++ _segdescr.vals[3] = 0x51; \
++ \
++ /* Install the TLS. */ \
++ asm volatile (TLS_LOAD_EBX \
++ "int $0x80\n\t" \
++ TLS_LOAD_EBX \
++ : "=a" (_result), "=m" (_segdescr.desc.entry_number) \
++ : "0" (__NR_set_thread_area), \
++ TLS_EBX_ARG (&_segdescr.desc), "m" (_segdescr.desc)); \
++ \
++ if (_result == 0) \
++ /* We know the index in the GDT, now load the segment register. \
++ The use of the GDT is described by the value 3 in the lower \
++ three bits of the segment descriptor value. \
++ \
++ Note that we have to do this even if the numeric value of \
++ the descriptor does not change. Loading the segment register \
++ causes the segment information from the GDT to be loaded \
++ which is necessary since we have changed it. */ \
++ TLS_SET_GS (_segdescr.desc.entry_number * 8 + 3); \
++ \
++ _result == 0 ? NULL \
++ : "set_thread_area failed when setting up thread-local storage\n"; })
++
++
++/* Return the address of the dtv for the current thread. */
++# define THREAD_DTV() \
++ ({ struct pthread *__pd; \
++ THREAD_GETMEM (__pd, header.dtv); })
++
++
++/* Return the thread descriptor for the current thread.
++
++ The contained asm must *not* be marked volatile since otherwise
++ assignments like
++ pthread_descr self = thread_self();
++ do not get optimized away. */
++# define THREAD_SELF \
++ ({ struct pthread *__self; \
++ asm ("movl %%gs:%c1,%0" : "=r" (__self) \
++ : "i" (offsetof (struct pthread, header.self))); \
++ __self;})
++
++/* Magic for libthread_db to know how to do THREAD_SELF. */
++# define DB_THREAD_SELF \
++ REGISTER_THREAD_AREA (32, offsetof (struct user_regs_struct, xgs), 3) \
++ REGISTER_THREAD_AREA (64, 26 * 8, 3) /* x86-64's user_regs_struct->gs */
++
++
++/* Read member of the thread descriptor directly. */
++# define THREAD_GETMEM(descr, member) \
++ ({ __typeof (descr->member) __value; \
++ if (sizeof (__value) == 1) \
++ asm volatile ("movb %%gs:%P2,%b0" \
++ : "=q" (__value) \
++ : "0" (0), "i" (offsetof (struct pthread, member))); \
++ else if (sizeof (__value) == 4) \
++ asm volatile ("movl %%gs:%P1,%0" \
++ : "=r" (__value) \
++ : "i" (offsetof (struct pthread, member))); \
++ else \
++ { \
++ if (sizeof (__value) != 8) \
++ /* There should not be any value with a size other than 1, \
++ 4 or 8. */ \
++ abort (); \
++ \
++ asm volatile ("movl %%gs:%P1,%%eax\n\t" \
++ "movl %%gs:%P2,%%edx" \
++ : "=A" (__value) \
++ : "i" (offsetof (struct pthread, member)), \
++ "i" (offsetof (struct pthread, member) + 4)); \
++ } \
++ __value; })
++
++
++/* Same as THREAD_GETMEM, but the member offset can be non-constant. */
++# define THREAD_GETMEM_NC(descr, member, idx) \
++ ({ __typeof (descr->member[0]) __value; \
++ if (sizeof (__value) == 1) \
++ asm volatile ("movb %%gs:%P2(%3),%b0" \
++ : "=q" (__value) \
++ : "0" (0), "i" (offsetof (struct pthread, member[0])), \
++ "r" (idx)); \
++ else if (sizeof (__value) == 4) \
++ asm volatile ("movl %%gs:%P1(,%2,4),%0" \
++ : "=r" (__value) \
++ : "i" (offsetof (struct pthread, member[0])), \
++ "r" (idx)); \
++ else \
++ { \
++ if (sizeof (__value) != 8) \
++ /* There should not be any value with a size other than 1, \
++ 4 or 8. */ \
++ abort (); \
++ \
++ asm volatile ("movl %%gs:%P1(,%2,8),%%eax\n\t" \
++ "movl %%gs:4+%P1(,%2,8),%%edx" \
++ : "=&A" (__value) \
++ : "i" (offsetof (struct pthread, member[0])), \
++ "r" (idx)); \
++ } \
++ __value; })
++
++
++/* Same as THREAD_SETMEM, but the member offset can be non-constant. */
++# define THREAD_SETMEM(descr, member, value) \
++ ({ if (sizeof (descr->member) == 1) \
++ asm volatile ("movb %b0,%%gs:%P1" : \
++ : "iq" (value), \
++ "i" (offsetof (struct pthread, member))); \
++ else if (sizeof (descr->member) == 4) \
++ asm volatile ("movl %0,%%gs:%P1" : \
++ : "ir" (value), \
++ "i" (offsetof (struct pthread, member))); \
++ else \
++ { \
++ if (sizeof (descr->member) != 8) \
++ /* There should not be any value with a size other than 1, \
++ 4 or 8. */ \
++ abort (); \
++ \
++ asm volatile ("movl %%eax,%%gs:%P1\n\t" \
++ "movl %%edx,%%gs:%P2" : \
++ : "A" (value), \
++ "i" (offsetof (struct pthread, member)), \
++ "i" (offsetof (struct pthread, member) + 4)); \
++ }})
++
++
++/* Set member of the thread descriptor directly. */
++# define THREAD_SETMEM_NC(descr, member, idx, value) \
++ ({ if (sizeof (descr->member[0]) == 1) \
++ asm volatile ("movb %b0,%%gs:%P1(%2)" : \
++ : "iq" (value), \
++ "i" (offsetof (struct pthread, member)), \
++ "r" (idx)); \
++ else if (sizeof (descr->member[0]) == 4) \
++ asm volatile ("movl %0,%%gs:%P1(,%2,4)" : \
++ : "ir" (value), \
++ "i" (offsetof (struct pthread, member)), \
++ "r" (idx)); \
++ else \
++ { \
++ if (sizeof (descr->member[0]) != 8) \
++ /* There should not be any value with a size other than 1, \
++ 4 or 8. */ \
++ abort (); \
++ \
++ asm volatile ("movl %%eax,%%gs:%P1(,%2,8)\n\t" \
++ "movl %%edx,%%gs:4+%P1(,%2,8)" : \
++ : "A" (value), \
++ "i" (offsetof (struct pthread, member)), \
++ "r" (idx)); \
++ }})
++
++
++/* Atomic compare and exchange on TLS, returning old value. */
++#define THREAD_ATOMIC_CMPXCHG_VAL(descr, member, newval, oldval) \
++ ({ __typeof (descr->member) __ret; \
++ __typeof (oldval) __old = (oldval); \
++ if (sizeof (descr->member) == 4) \
++ asm volatile (LOCK_PREFIX "cmpxchgl %2, %%gs:%P3" \
++ : "=a" (__ret) \
++ : "0" (__old), "r" (newval), \
++ "i" (offsetof (struct pthread, member))); \
++ else \
++ /* Not necessary for other sizes in the moment. */ \
++ abort (); \
++ __ret; })
++
++
++/* Atomic set bit. */
++#define THREAD_ATOMIC_BIT_SET(descr, member, bit) \
++ (void) ({ if (sizeof ((descr)->member) == 4) \
++ asm volatile (LOCK_PREFIX "orl %1, %%gs:%P0" \
++ :: "i" (offsetof (struct pthread, member)), \
++ "ir" (1 << (bit))); \
++ else \
++ /* Not necessary for other sizes in the moment. */ \
++ abort (); })
++
++
++/* Call the user-provided thread function. */
++#define CALL_THREAD_FCT(descr) \
++ ({ void *__res; \
++ int __ignore1, __ignore2; \
++ asm volatile ("pushl %%eax\n\t" \
++ "pushl %%eax\n\t" \
++ "pushl %%eax\n\t" \
++ "pushl %%gs:%P4\n\t" \
++ "call *%%gs:%P3\n\t" \
++ "addl $16, %%esp" \
++ : "=a" (__res), "=c" (__ignore1), "=d" (__ignore2) \
++ : "i" (offsetof (struct pthread, start_routine)), \
++ "i" (offsetof (struct pthread, arg))); \
++ __res; })
++
++
++#endif /* __ASSEMBLER__ */
++
++#endif /* tls.h */